#!/usr/local/bin/perl



# 0 = character, 1 = signed short integer, 2 = unsigned integer, 3 = float
# 8 bit          16bit                     32bit                 32bit

@datatype = ('a','s','i','f','c');
@datalength = ( 1 , 2 , 4 , 4 , 1 );

$file_name_mdm = 'body.mdm'; # Filename to import
$file_name_mdx = 'body.mdx';

$file_name_mds = 'c:\body.mds'; # Filename to export

$file_name_bone = 'bonelist.dat';
$file_name_tag = 'taglist2.dat';


if(!open(MDM,$file_name_mdm)){print"Failed to open file.\n"; exit;}

print"Opened MDM file.\nReading data.\n";

binmode MDM;

while($DATA[$i] = <MDM>){$i++;}

close(MDM);

$CUTDATA1 = join('',@DATA);

@DATA = ('');

if(!open(MDX,$file_name_mdx)){print"Failed to open file.\n"; exit;}

print"Opened MDX file.\nReading data.\n";

binmode MDX;

while($DATA[$i] = <MDX>){$i++;}

close(MDX);

$CUTDATA2 = join('',@DATA);

print"Data loaded.\nStarting marge.\n";

####################################################

$mdm_ident = &cut1( 0 , 4 );
$mdm_version = &cut1( 2 , 1 );
$mdm_name = &cut1( 0 , 64 );
$LoD_scale = &cut1( 3 , 1 ); # ?
$LoD_bias = &cut1( 2 , 1 ); # ??
$num_surfaces = &cut1( 2 , 1 );
$mdm_offset_surface = &cut1( 2 , 1 );
$num_tags = &cut1( 2 , 1 );
$mdm_offset_tag = &cut1( 2 , 1 );
$mdm_file_size = &cut1( 2 , 1 );

###################################################

print<<EOM;
$mdm_ident
$mdm_version
$mdm_name
$LoD_scale
$LoD_bias
$num_surfaces
$mdm_offset_surface
$num_tags
$mdm_offset_tag
$mdm_file_size
EOM

###################################################

$mdx_ident = &cut2( 0 , 4 );
$mdx_version = &cut2( 2 , 1 );
$mdx_name = &cut2( 0 , 64 );
$num_frames = &cut2( 2 , 1 );
$num_bones = &cut2( 2 , 1 );
$mdx_offset_frames = &cut2( 2 , 1 );
$mdx_offset_bones = &cut2( 2 , 1 );
$torsoparent = &cut2( 2, 1 );
$mdx_file_size = &cut2( 2 , 1 );

###################################################

print<<EOM;
$mdx_ident
$mdx_version
$mdx_name
$num_frames
$num_bones
$mdx_offset_frames
$mdx_offset_bones
$torsoparent
$mdx_file_size
EOM

###################################################

$size_surfaces = $mdm_offset_tag - $mdm_offset_surface;
$size_tags = 72 * $num_tags;
$size_frames = $mdx_offset_bones - $mdx_offset_frames;
$size_bones = $mdx_file_size - $mdx_offset_bones;
$size_mdm_tags = $mdm_file_size - $mdm_offset_tag;

###################################################

print<<EOM;
$size_surfaces
$size_tags
$size_frames
$size_bones
EOM

###################################################

&add( 'MDSW' , 0 , 4 );
&add( 4 , 2 , 1 );
&add( 'marged/model.mds' , 0 ,  64 );
&add( $LoD_scale , 2 , 1 );
&add( $LoD_bias , 2 , 1 );
&add( $num_frames , 2 , 1 );
&add( $num_bones , 2 , 1 );
&add( 120 + $size_bones + $size_tags , 2 , 1 );
&add( 120 , 2 , 1 );
&add( $torsoparent , 2, 1 );
&add( $num_surfaces , 2 , 1 );
&add( 120 + $size_bones + $size_tags + $size_frames , 2 , 1);
&add( $num_tags , 2 , 1 );
&add( 120 + $size_bones , 2 , 1 );
&add( 120 + $size_bones + $size_tags + $size_frames + $size_surfaces , 2 , 1 );

###################################################

$out = $out . substr( $CUTDATA2 , $mdx_offset_bones , $size_bones );

if(!open(BON,">$file_name_bone")){print 'Oops!';exit;}
binmode BON;
print BON substr( $CUTDATA2 , $mdx_offset_bones , $size_bones );
close(BON);

$q = $mdx_offset_bones;

for ( $bi = 0; $bi < $num_bones; $bi++ ){

$bonename[$bi] = &cut2( 0 , 64 );
$parentIndex[$bi] = &cut2( 2 , 1 );
$torsoWeight[$bi] = &cut2( 3 , 1 );
$parentDist[$bi] = &cut2( 3 , 1 );
$flag = &cut2( 2 , 1 );

}

###################################################

$p = $mdm_offset_tag;

if(!open(TAG,">$file_name_tag")){print 'Oops!';exit;}
binmode TAG;
print TAG substr( $CUTDATA1 , $mdm_offset_tag , $size_mdm_tags );
close(TAG);

for ( $ti = 0; $ti < $num_tags; $ti++ ){

$point = $p;

$tag_name = &cut1( 0 , 64 );
$unused = &cut1( 3 , 9 );
$bone_index = &cut1( 2 , 1 );
$unused = &cut1( 3 , 5 );

$p = $point + &cut1( 2 , 1 );

&add( $tag_name , 0 , 64 );
&add( 0 , 3 , 1 );
&add( $bone_index , 2 , 1 );

}

###################################################

$out = $out . substr( $CUTDATA2 , $mdx_offset_frames , $size_frames );

$q = $mdx_offset_frames;

for ( $fi = 0; $fi < $num_frames; $fi++ ){

$bboxMin1[$fi] = &cut2( 3 , 1 );
$bboxMin2[$fi] = &cut2( 3 , 1 );
$bboxMin3[$fi] = &cut2( 3 , 1 );
$bboxMax1[$fi] = &cut2( 3 , 1 );
$bboxMax2[$fi] = &cut2( 3 , 1 );
$bboxMax3[$fi] = &cut2( 3 , 1 );
$radius[$fi] = &cut2( 3 , 1 );
$parentOffset1 = &cut2( 3 , 1 );
$parentOffset2 = &cut2( 3 , 1 );
$parentOffset3 = &cut2( 3 , 1 );

$angle1[$fi] = &cut2( 1 , 1 ) * 360 / 65536;
$angle2[$fi] = &cut2( 1 , 1 ) * 360 / 65536;
$angle3[$fi] = &cut2( 1 , 1 ) * 360 / 65536;
$angle4[$fi] = &cut2( 1 , 1 ) * 360 / 65536; # unused
$offsetAngle1[$fi] = &cut2( 1 , 1 ) * 360 / 65536;
$offsetAngle2[$fi] = &cut2( 1 , 1 ) * 360 / 65536;

}

###################################################

$off_surface = length( $out );

$p = $mdm_offset_surface;

for ($si = 0; $si < $num_surfaces; $si++ ){

$point = $p;

$offset_header = - length( $out );

$surface_ident = &cut1( 2 , 1 ); # 0x0009
$surface_name = &cut1( 0 , 64 );
$shader_name = &cut1( 0 , 64 );
$shader_index = &cut1( 2 , 1 );
$unknown1 = &cut1( 2 , 1 ); # ???
$surface_header_offset = &cut1( 2 , 1 ); # Always negative 
$num_vertices = &cut1( 2 , 1 );
$offset_vertices = &cut1( 2 , 1 );
$num_triangles = &cut1( 2 , 1 );
$offset_triangles = &cut1( 2 , 1 );
$offset_collaspemap = &cut1( 2 , 1 ); # not sure but probably offset
$unknown2 = &cut1( 2 , 1 ); # ??? kind of number or index
$offset_bonerefs = &cut1( 2 , 1 ); # ??? offset maybe
$offset_surface_data_end = &cut1( 2 , 1 );

print $p . "\n" . $surface_name . "\n";

&add( 8 , 2 , 1 );
&add( $surface_name , 0 , 64 );
&add( $shader_name , 0 , 64 );
&add( $shader_index , 2 , 1 );
&add( $unknown1 , 2 , 1 );
&add( $offset_header , 2 , 1 );
&add( $num_vertices , 2 , 1 );
&add( $offset_vertices , 2 , 1 );
&add( $num_triangles , 2 , 1 );
&add( $offset_triangles + 8 * $num_vertices , 2 , 1 );
&add( $offset_collaspemap + 8 * $num_vertices , 2 , 1 );
&add( $unknown2 , 2 , 1 );
&add( $offset_bonerefs + 8 * $num_vertices , 2 , 1 );
&add( $offset_surface_data_end + 8 * $num_vertices , 2 , 1 );

for ( $vi = 0; $vi < $num_vertices; $vi++ ){

$vertex_postion_vector_x = &cut1( 3 , 1 );
$vertex_postion_vector_y = &cut1( 3 , 1 );
$vertex_postion_vector_z = &cut1( 3 , 1 );

$texture_coordinates_pos_u = &cut1( 3 , 1 );
$texture_coordinates_pos_v = &cut1( 3 , 1 );

$num_bone_weights = &cut1( 2 , 1 );

for ($bi = 0; $bi < $num_bone_weights; $bi++ ){

$bone_indexed[$bi] = &cut1( 2 , 1 );
$weight[$bi] = &cut1( 3 , 1 );
$bone_space1[$bi] = &cut1( 3 , 1 );
$bone_space2[$bi] = &cut1( 3 , 1 );
$bone_space3[$bi] = &cut1( 3 , 1 );

}

&add( $vertex_postion_vector_x , 3 , 1 );
&add( $vertex_postion_vector_y , 3 , 1 );
&add( $vertex_postion_vector_z , 3 , 1 );
&add( $texture_coordinates_pos_u , 3 , 1 );
&add( $texture_coordinates_pos_v , 3 , 1 );
&add( $num_bone_weights , 2, 1 );
&add( 0 , 2 , 1 );
&add( 0 , 3 , 1 );

for ($bi = 0; $bi < $num_bone_weights; $bi++ ){

&add( $bone_indexed[$bi] , 2 ,1 );
&add( $weight[$bi] , 3 , 1 );
&add( $bone_space1[$bi] , 3 , 1 );
&add( $bone_space2[$bi] , 3 , 1 );
&add( $bone_space3[$bi] , 3 , 1 );

}

}

$out = $out . substr( $CUTDATA1 , $point + $offset_triangles , $offset_surface_data_end - $offset_triangles );

$p = $point + $offset_surface_data_end;

}

###################################################

$filesize = length( $out );

if( $filesize == 120 + $size_bones + $size_tags + $size_frames + $filesize - $off_surface ){ print "OK!\n"; }else{print "NG!\n";exit;}

substr( $out , 104 , 4 ) = pack( "i" , $off_surface );

substr( $out , 116 , 4 ) = pack( "i" , $filesize );

###################################################

if(!open(MDS,">$file_name_mds")){print 'Oops!';exit;}
binmode MDS;
print MDS $out;
close(MDS);

###################################################

# add( DATA TO ADD , DATATYPE , AMMOUNT ) 

sub add{

$ret = '';

if( $_[2] == 1 ){

$ret = pack( $datatype[$_[1]] , $_[0] ) ;

}else{

for ( $r = 0; $r < $_[2]; $r++ ){

$ret = $ret . pack( $datatype[$_[1]] , substr( $_[0] , $r * $datalength[$_[1]] , $datalength[$_[1]] ) ) ;

}

}

$out = $out . $ret;

}

# cut( DATATYPE , AMMOUNT ) 

sub cut1{

$g = '';

for ( $r = 0; $r < $_[1]; $r++ ){

$g = $g . unpack( $datatype[$_[0]] , substr($CUTDATA1,$p,$datalength[$_[0]]) ) ;

$p += $datalength[$_[0]];

}

return $g;

}

sub cut2{

$g = '';

for ( $r = 0; $r < $_[1]; $r++ ){

$g = $g . unpack( $datatype[$_[0]] , substr($CUTDATA2,$q,$datalength[$_[0]]) ) ;

$q += $datalength[$_[0]];

}

return $g;

}