
@datatype = ('a','s','i','f','c');
@datalength = ( 1 , 2 , 4 , 4 , 1 );

$mds_filename = 'body.mds';
$output_mdm_name = 'body.mdm';
$ref_tag_filename = 'taglist.dat';
$ref_bone_filename = 'bonelist.dat';

$mdm_header_size = 104;

@mdm_bone_name = ('Bip01 Pelvis' , 'Bip01 Spine' , 'Bip01 Spine1','Bip01 Spine2','Bip01 Spine3','Bip01 Neck','Bip01 Head','Bip01 L Clavicle','Bip01 L UpperArm','Bip01 L Forearm','Bip01 L Hand','Bip01 L Finger0','Bip01 L Finger01','Bip01 L Finger02','Bip01 L Finger1','Bip01 L Finger11','Bip01 L Finger12','Bip01 L Finger2','Bip01 L Finger21','Bip01 L Finger22','Bip01 L Finger3','Bip01 L Finger31','Bip01 L Finger32','Bip01 L Finger4','Bip01 L Finger41','Bip01 L Finger42','Bip01 R Clavicle','Bip01 R UpperArm','Bip01 R Forearm','Bip01 R Hand','Bip01 R Finger0','Bip01 R Finger01','Bip01 R Finger02','Bip01 R Finger1','Bip01 R Finger11','Bip01 R Finger12','Bip01 R Finger2','Bip01 R Finger21','Bip01 R Finger22','Bip01 R Finger3','Bip01 R Finger31','Bip01 R Finger32','Bip01 R Finger4','Bip01 R Finger41','Bip01 R Finger42','Bip01 L Thigh','Bip01 L Calf','Bip01 L Foot','Bip01 L Toe0','Bip01 R Thigh','Bip01 R Calf','Bip01 R Foot','Bip01 R Toe0');

$mdm_bone_number = $#mdm_bone_name + 1;

$rbone_num = $#bones_name ;

if(!open(MDS,$mds_filename)){print"Failed to open file.\n"; exit;}

print"Opened MDS file.\nReading data.\n";

binmode MDS;

while($DATA[$i] = <MDS>){$i++;}

close(MDS);

$CUTDATA1 = join('',@DATA);

@DATA = ('');

################################################################################

# bone

if(!open(BON,$ref_bone_filename)){print"Failed to open bone reference file.\n"; exit;}

print"Opened bone reference file.\nReading data.\n";

binmode BON;

while($DATA[$i] = <BON>){$i++;}

close(BON);

$new_mdm_bone = join('',@DATA);

@DATA = ('');

$p = 84;

$mds_bone_number = &cut1( 2 , 1);

$p = 92;

$mds_bone_offset = &cut1( 2 , 1 );

$p = $mds_bone_offset;

for ( $i = 0; $i < $mds_bone_number; $i++ ){

$mds_bone_name[$i] = &cut1( 0 , 64 );
$mds_bone_parentIndex[$i] = &cut1( 2 , 1 );
$mds_bone_torsoWeight[$i] = &cut1( 3 , 1 );
$mds_bone_parentDist[$i] = &cut1( 3 , 1);
$mds_bone_frag[$i] = &cut1( 2 , 1 );

}

$k = 0;

for ( $i = 0; $i < $mds_bone_number; $i++ ){

 for ( $j = $k; $j < $mdm_bone_number; $j++ ){

  if ( $mdm_bone_name[$j] eq substr( $mds_bone_name[$i] , 0 , length( $mdm_bone_name[$j]) ) ){ 
  print "MDS BONE #$i matches reference MDM BONE #$j.\n";
  $mds_to_mdm_bone_parentIndex[$i] = $j;
  $mdm_to_mds_bone_parentIndex[$j] = $i;
  $mdm_bone_match[$j] = 1;
  $k = $j + 1;
  $j = $mdm_bone_number;
  $mds_bone_match[$i] = 1;
  }
 
 }

}

################################################################################

# tag

if(!open(TAG,$ref_tag_filename)){print"Failed to open tag reference file.\n"; exit;}

print"Opened tag reference file.\nReading data.\n";

binmode TAG;

while($DATA[$i] = <TAG>){$i++;}

close(TAG);

$new_mdm_tag = join('',@DATA);

@DATA = ('');

$new_mdm_tag_size = length( $new_mdm_tag );

################################################################################

# surface


print "Proceeding surface.\n";

$p = 100;

$mds_surface_number = &cut1( 2 , 1 );
$mds_surface_offset = &cut1( 2 , 1 );

print "Surface number:$mds_surface_number\nSurface offset:$mds_surface_offset\n";

$p = $mds_surface_offset;

for ( $i = 0; $i < $mds_surface_number; $i++ ){

$new_mdm_surface_boneref_number = 0;
$new_mdm_surface_vertex_number = 0;
$point = $p;

$ident = &cut1( 2 , 1 );
$mds_surface_name = &cut1( 0 , 64 );
$mds_surface_shader_name = &cut1( 0 , 64 );
$mds_surface_shader_index = &cut1( 2 , 1 );
$mds_surface_minLoD = &cut1( 2 , 1 );
$dummy = &cut1( 2 , 1 );
$mds_surface_vertex_number = &cut1( 2 , 1 );
$mds_surface_vertex_offset = &cut1( 2 , 1 );
$mds_surface_triangle_number = &cut1( 2 , 1 );
$mds_surface_triangle_offset = &cut1( 2 , 1 );
$mds_surface_collapsemap_offset = &cut1( 2 , 1 );
$mds_surface_boneref_number = &cut1( 2 , 1 );
$mds_surface_boneref_offset = &cut1( 2 , 1 );
$nextoffset = &cut1( 2 , 1 );

$p = $point + $mds_surface_vertex_offset;

print " Surface #$i vertices:$mds_surface_vertex_number\n";
for ( $j = 0; $j < $mds_surface_vertex_number; $j++ ){

$mds_vertex_normal1 = &cut1( 3 , 1 );
$mds_vertex_normal2 = &cut1( 3 , 1 );
$mds_vertex_normal3 = &cut1( 3 , 1 );

$mds_vertex_coord1 = &cut1( 3 , 1 );
$mds_vertex_coord2 = &cut1( 3 , 1 );

$mds_vertex_numWeights = &cut1( 2 , 1 );
$mds_vertex_fixedParent = &cut1( 2 , 1 );
$mds_vertex_fixedDist = &cut1( 3 , 1 );

$wc = 0;
$wt = 0;
for ( $k = 0; $k < $mds_vertex_numWeights; $k++ ){

$mds_vertex_weight_boneIndex[$wc] = &cut1( 2 , 1 );

if ( $mds_bone_match[$mds_vertex_weight_boneIndex] == 1 ){

$mds_vertex_weight_weight[$wc] = &cut1( 3 , 1 );
$mds_vertex_weight_x[$wc] = &cut1( 3 , 1 );
$mds_vertex_weight_y[$wc] = &cut1( 3 , 1 );
$mds_vertex_weight_z[$wc] = &cut1( 3 , 1 );

$wt = $wt + $mds_vertex_weight_weight[$wc];
$wc++;

}else{

$dummy = &cut1( 3 , 4 );

}

} # end of weight's for

#if ( $wc > 0 ){

&add( $mds_vertex_normal1 , 3 , 1 );
&add( $mds_vertex_normal2 , 3 , 1 );
&add( $mds_vertex_normal3 , 3 , 1 );

&add( $mds_vertex_coord1 , 3 , 1 );
&add( $mds_vertex_coord2 , 3 , 1 );

&add( $wc , 2 , 1 );
#&add( $mds_vertex_fixedParent , 2 , 1 );
#&add( $mds_vertex_fixedDist , 3 , 1 );

for ( $k = 0; $k < $wc; $k++ ){

&add( $mds_to_mdm_bone_parentIndex[$mds_vertex_weight_boneIndex[$k]] , 2 , 1 );
&add( $mds_vertex_weight_weight[$k] / $wt , 3 , 1 );
&add( $mds_vertex_weight_x[$k] , 3 , 1 );
&add( $mds_vertex_weight_y[$k] , 3 , 1 );
&add( $mds_vertex_weight_z[$k] , 3 , 1 );

}

$new_mdm_surface_vertex_number++;

} # end of vertex's for

$new_mdm_surface_vertex = $out;

$out = '';

$new_mdm_surface_vertex_size = length( $new_mdm_surface_vertex );

# triangle

$new_mdm_surface_triangle = substr( $CUTDATA1 , $point + $mds_surface_triangle_offset , 3 * 4 * $mds_surface_triangle_number );

$new_mdm_surface_triangle_size = length( $new_mdm_surface_triangle );
$new_mdm_surface_triangle_number = $mds_surface_triangle_number;

# collapsemap

$new_mdm_surface_collapsemap = substr( $CUTDATA1 , $point + $mds_surface_collapsemap_offset , $mds_surface_boneref_offset - $mds_surface_collapsemap_offset );

$new_mdm_surface_collapsemap_size = length( $new_mdm_surface_collapsemap );

# bone references

$p = $point + $mds_surface_boneref_offset;

for ( $j = 0; $j < $mds_surface_boneref_number; $j++ ){

$mds_surface_boneref_index = &cut1( 2 , 1 );

if ( $mds_bone_match[$mds_surface_boneref_index] == 1 ){

&add( $mds_to_mdm_bone_parentIndex[$mds_surface_boneref_index] , 2 , 1 );

$new_mdm_surface_boneref_number++;

}

}

$new_mdm_surface_boneref = $out;
$new_mdm_surface_boneref_size = length( $new_mdm_surface_boneref );

$out = '';

# surface overall

# header

&add( 9 , 2 , 1 );
&add( $mds_surface_name , 0 , 64 );
&add( $mds_surface_shader_name , 0 , 64 );
&add( $mds_surface_shader_index , 2 , 1 );
&add( $mds_surface_minLoD , 2 , 1 );
&add( -( 100 + length( $new_mdm_surface ) ) , 2 , 1 );
&add( $new_mdm_surface_vertex_number , 2 , 1 );
&add( 176 , 2 , 1 );
&add( $new_mdm_surface_triangle_number , 2 , 1 );
&add( 176 + $new_mdm_surface_vertex_size , 2 , 1 );
&add( 176 + $new_mdm_surface_vertex_size + $new_mdm_surface_triangle_size , 2 , 1 );
&add(  $new_mdm_surface_boneref_number , 2 , 1 );
&add( 176 + $new_mdm_surface_vertex_size + $new_mdm_surface_triangle_size + $new_mdm_surface_collapsemap_size , 2 , 1 );
&add( 176 + $new_mdm_surface_vertex_size + $new_mdm_surface_triangle_size + $new_mdm_surface_collapsemap_size + $new_mdm_surface_boneref_size , 2 , 1 );

$new_mdm_surface = $new_mdm_surface . $out . $new_mdm_surface_vertex . $new_mdm_surface_triangle . $new_mdm_surface_collapsemap . $new_mdm_surface_boneref;

$out = '';

$p = $point + $nextoffset;

}

$new_mdm_surface_size = length( $new_mdm_surface );

###############################################################################

# MDM header

&add( 'MDMW' , 0 , 4 );
&add( 3 , 2 , 1 );
&add( 'models/players/temperate/model.mdm' , 0 , 64 );

$p = 76;
&add( &cut1( 3 , 1 ) , 3 , 1 );
&add( &cut1( 3 , 1 ) , 3 , 1 );
&add( $mds_surface_number , 2 , 1 );
&add( 100 , 2 , 1 );
&add( 17 , 2 , 1 );
&add( 100 + $new_mdm_surface_size , 2 , 1 );
&add( 100 + $new_mdm_surface_size + $new_mdm_tag_size , 2 , 1 );

$new_mdm_header = $out;
$out = '';

###############################################################################

$new_mdm = $new_mdm_header . $new_mdm_surface . $new_mdm_tag;

###############################################################################

if(!open(MDM,">$output_mdm_name")){print"Failed to open file.\n"; exit;}

print"Opened MDM file.\nWriting data.\n";

binmode MDM;

print MDM $new_mdm;

close(MDM);

###############################################################################

sub add{

$ret = '';

if( $_[2] == 1 ){

$ret = pack( $datatype[$_[1]] , $_[0] ) ;

}else{

for ( $r = 0; $r < $_[2]; $r++ ){

$ret = $ret . pack( $datatype[$_[1]] , substr( $_[0] , $r * $datalength[$_[1]] , $datalength[$_[1]] ) ) ;

}

}

$out = $out . $ret;

}


sub cut1{

$g = '';

for ( $r = 0; $r < $_[1]; $r++ ){

$g = $g . unpack( $datatype[$_[0]] , substr($CUTDATA1,$p,$datalength[$_[0]]) ) ;

$p += $datalength[$_[0]];

}

return $g;

}

