#
# MDM&MDX(=MDS) vertex posiotion calculation module
#
# Hey, do you want to know where vertices are at each frame?
# First you must know that calculating a vertex position requires the bones 
# positions in 3D space. Because vertices are made by attaching to the bone
# space. Each bone has its own orientation system and origin.
# So, we should calculate where the bone origin is first, next the rotation
# matrix to transform regular xyz into bone orientation system.

$fi = 0;

#for ( $fi = 0; $fi < $num_flames; $fi++ ){ # delete head # if you are ready to proceed all frames.

# where are the bones in 3D space?

$bi = 0;

for ( $bi = 0; $bi < $num_bones; $bi++ ){

	( $dx , $dy , $dz ) = &pitch_and_yaw_on_x( $parentDist[$bi] , $offsetAngles1[$bi] , $offsetAngles2[$bi] );

	if ( $parentIndex[$bi] == -1 ){

		$bonepos_x[$bi] = $parentOffsetx[$fi] + dx;
		$bonepos_y[$bi] = $parentOffsety[$fi] + dy;
		$bonepos_z[$bi] = $parentOffsetz[$fi] + dz;

	}else{

		$bonepos_x[$bi] = $bonepos_x[$parentIndex[$bi]] + dx;
		$bonepos_y[$bi] = $bonepos_y[$parentIndex[$bi]] + dy;
		$bonepos_z[$bi] = $bonepos_z[$parentIndex[$bi]] + dz;

	}

	# What is the rotation matrix to transform a space vector to each bone's orientation system?

	( $rot_matrix_x_1[$bi] , $rot_matrix_y_1[$bi] , $rot_matrix_z_1[$bi] ) = &rotation_matrix( 1 , 0 , 0 );
	( $rot_matrix_x_2[$bi] , $rot_matrix_y_2[$bi] , $rot_matrix_z_2[$bi] ) = &rotation_matrix( 0 , 1 , 0 );
	( $rot_matrix_x_3[$bi] , $rot_matrix_y_3[$bi] , $rot_matrix_z_3[$bi] ) = &rotation_matrix( 0 , 0 , 1 );

}

# Okay, now let's calculate where the vertices are!


for ( $vi = 0; $vi < $num_vertices; $vi++ ){

	for ( $wi = 0; $wi < $numWeights; $wi++ ){

		$vertexpos_x[$vi] += $weight[$wi] * ( $bonepos_x[$boneIndex] + $rot_matrix_x_1[$boneIndex] * $x[$wi] + $rot_matrix_x_2[$boneIndex] * $y[$wi] + $rot_matrix_x_3[$boneIndex] * $z[$wi] );
		$vertexpos_y[$vi] += $weight[$wi] * ( $bonepos_y[$boneIndex] + $rot_matrix_y_1[$boneIndex] * $x[$wi] + $rot_matrix_y_2[$boneIndex] * $y[$wi] + $rot_matrix_y_3[$boneIndex] * $z[$wi] );
		$vertexpos_z[$vi] += $weight[$wi] * ( $bonepos_z[$boneIndex] + $rot_matrix_z_1[$boneIndex] * $x[$wi] + $rot_matrix_z_2[$boneIndex] * $y[$wi] + $rot_matrix_z_3[$boneIndex] * $z[$wi] );

	}

	# Heres some ristriction that distance of vertex and specific bone.

	$distance = ( ( $bonepos_x[$fixedParent] - $vertexpos_x[$vi] ) ^ 2 + ( $bonepos_y[$fixedParent] - $vertexpos_y[$vi] ) ^ 2 + ( $bonepos_z[$fixedParent] - $vertexpos_z[$vi] ) ^ 2 ) ^ ( 1 / 2 );

	if ( $distance > $fixedDist[$vi] ){

		$vertexpos_x[$vi] = ( $bonepos_x[$fixedParent] - $vertexpos_x[$vi] ) * ( $fixedDist[$vi] / $distance ) + $bonepos_x[$fixedParent];
		$vertexpos_y[$vi] = ( $bonepos_y[$fixedParent] - $vertexpos_y[$vi] ) * ( $fixedDist[$vi] / $distance ) + $bonepos_y[$fixedParent];
		$vertexpos_z[$vi] = ( $bonepos_z[$fixedParent] - $vertexpos_z[$vi] ) * ( $fixedDist[$vi] / $distance ) + $bonepos_z[$fixedParent];

	}

}

#
# Output vertexpos and others you wish here at this frame.
#

#} # delete head # if you are ready to proceed all frames.

###############################################################################

# yaw( x , y , z , degree ) = matrix of z-axis-fixed rotation, x-y plane rotates.

sub yaw{

$_[3] = $_[3] / 360 * 2 * 3.1415;

return ( $_[0] * cos( $_[3] ) - $_[1] * sin( $_[3] ) , $_[0] * sin( $_[3] ) + $_[1] * cos( $_[3] ) , $_[2] );

#}   # delete # if you are ready to proceed all frames.

###############################################################################

# pitch( x , y , z , degree ) = matrix of y-axis-fixed rotation, z-x plane rotates.

sub pitch{

$_[3] = $_[3] / 360 * 2 * 3.1415;

return ( $_[0] * cos( $_[3] ) + $_[2] * sin( $_[3] ) , $_[1] , -$_[0] * sin( $_[3] ) + $_[2] * cos( $_[3] ) );

}

###############################################################################

# roll( x , y , z , degree ) = matrix of x-axis-fixed rotation, y-z plane rotates.

sub roll{

$_[3] = $_[3] / 360 * 2 * 3.1415;

return ( $_[0] , $_[2] * cos( $_[3] ) - $_[1] * sin( $_[3] ) , $_[2] * sin( $_[3] ) + $_[1] * cos( $_[3] ) );

}

###############################################################################

# pitch_and_yaw_on_x( X-Distance , Degree of ptich , Degree of yaw ) = position that rotated in pitch and yaw

# yaw , pitch

sub pitch_and_yaw_on_x{

$_[1] = $_[1] / 360 * 2 * 3.1415;
$_[2] = $_[2] / 360 * 2 * 3.1415;

return ( $_[0] * cos( $_[1] ) * cos( $_[2] ) , $_[0] * sin( $_[2] ) , -$_[0] * sin( $_[1] ) * cos( $_[2] ) );

}

###############################################################################

sub rotation_matrix{

( $orient1 , $orient2 , $orient3 ) = ( $_[0] , $_[1] , $_[2] );
# Roll
( $orient1 , $orient2 , $orient3 ) = &roll( $orient1 , $orient2 , $orient3 , $angles3[$bi] );
# Pitch
( $orient1 , $orient2 , $orient3 ) = &pitch( $orient1 , $orient2 , $orient3 , $angles2[$bi] );
# Yaw
( $orient1 , $orient2 , $orient3 ) = &yaw( $orient1 , $orient2 , $orient3 , $angles1[$bi] );

return ( $orient1 , $orient2 , $orient3 );

}
