

$file_name = 'test.mdm'; # Filename to import
$output_file = 'out.html';

$char = 1;
$int32 = 4;
$float = 4;

$p = 0;

$output = $output . "<HTML><HEAD><TITLE>MDM Analyzer</TITLE></HEAD><BODY><PRE>\n";
$output = $output . "---------------------------------------------\n";
$output = $output . "MDM Checker beta version by ikanatto\n";
$output = $output . "---------------------------------------------\n";

if(!open(MDM,$file_name)){$output = $output ."Failed to open file.\n"; exit;}else{$output = $output ."Opened MDM file.\nReading data.\n";}

binmode MDM;

while($DATA[$i] = unpack("H*",<MDM>)){$i++;}

close(MDM);

$CUTDATA = join('',@DATA);

$output = $output ."Data loaded.\nStarting analyze.\n";

####################################################

$mdm_ident = &cut( $char * 4 );
$version = &cut( $int32 * 1 );
$mdm_name = &cut( $char * 64 );
$LoD_scale = &cut( $float * 1 ); # ? not sure this detail
$LoD_bias = &cut( $float * 1 ); # ?? maybe determination of LoD with angle state
$num_surfaces = hex( &cut( $int32 * 1 ) );
$surface_data_offset = &cut( $int32 * 1 );
$num_tags = hex( &cut( $int32 * 1 ) );
$tag_data_offset = &cut( $int32 * 1 );
$file_size = hex( &cut( $int32 * 1 ) );

###################################################

for ($aa = 0; $aa < 64; $aa++ ){
$mdm_name_str = pack("H2",substr($mdm_name,$aa*2,2)) . $mdm_name_str;
}

$output = $output . <<EOM;

---------------------------------------------
MDM Header section
---------------------------------------------
  MDM model name:$mdm_name_str
  LoD scale:$LoD_scale
  LoD bias:$LoD_bias
  Surface number:$num_surfaces
  Surface data offset:$surface_data_offset
  Tag number:$num_tags
  Tag data offset:$tag_data_offset
  File size(Byte):$file_size

EOM

###################################################

for ( $sn = 0; $sn < $num_surfaces; $sn++ ){


$point = $p;

$surface_ident = &cut( $int32 * 1 ); # 0x0009
$surface_name = &cut( $char * 64 );
$shader_name = &cut( $char * 64 );
$shader_index = hex( &cut( $int32 * 1 ) );
$unknown1 = &cut( $int32 * 1 ); # ???
$surface_header_offset = hex( &cut( $int32 * 1 ) ); # Always negative 
$num_vertices = hex( &cut( $int32 * 1 ) );
$offset_vertices = &cut( $int32 * 1 );
$num_triangles = hex( &cut( $int32 * 1 ) );
$offset_triangles = &cut( $int32 * 1 );
$offset_collaspemap = &cut( $int32 * 1 ); # not sure but probably offset
$unknown2 = &cut( $int32 * 1); # ??? kind of number or index
$offset_bonerefs = &cut( $int32 * 1 ); # ??? offset maybe
$offset_surface_data_end = hex( &cut( $int32 * 1 ) );

####################################################

$sur_name = '';
$sdr_name = '';

for ($aa = 0; $aa < 64; $aa++ ){
$sur_name = pack("H2",substr($surface_name,$aa*2,2)) . $sur_name;
}

for ($aa = 0; $aa < 64; $aa++ ){
$sdr_name = pack("H2",substr($shader_name,$aa*2,2)) . $sdr_name;
}

$output = $output .<<EOM;

---------------------------------------------
Surface $sn section
---------------------------------------------
  Surface name:$sur_name
  Shader name:$sdr_name
  Shader index:$shader_index
  Vertex number:$num_vertices
  Vertex data offset:$offset_vertices
  Triangle number:$num_triangles
  Triangle data offset:$offset_triangles
  Collapsemap data offset:$offset_collaspemap
  Bone Reference data offset:$offset_bonerefs
  Surface data size:$offset_surface_data_end

EOM

$p = $point + $offset_surface_data_end * 2;

}

####################################################

for ( $tn = 0; $tn < $num_tags; $tn++ ){

$t_name = '';
@bone_index_list = ('');

$tag_name = &cut( $char * 64 );

for ( $vi = 0; $vi < 9; $vi++ ) {

$tag_triangles_vector[$vi] = &cut( $float * 1 );

}

$attach_bone_number = hex( &cut( $int32 * 1 ) ); # silly assumption

for ( $vi = 0; $vi < 3; $vi++ ) {

$tag_pos_to_bone[$vi] = &cut( $float * 1 ); # position vector where tag's triangle is near bone

}

$bone_number_list_size = hex( &cut( $int32 * 1 ) );

$bone_list_offset = &cut( $int32 * 1 ); 

$tag_data_size = hex( &cut( $int32 * 1 ) );

for ( $cc = 0; $cc < $bone_number_list_size; $cc++ ) {

$bone_index_list[$cc] = hex( &cut( $int32 * 1) );

}

#

for ($aa = 0; $aa < 64; $aa++ ){
$t_name = pack("H2",substr($tag_name,$aa*2,2)) . $t_name;
}

$bone_index_list_a = join(' , ',@bone_index_list);

$output = $output .<<EOM;

---------------------------------------------
Tag $tn section
---------------------------------------------

  Tag name:$t_name
  Tag triangle vertices vectors:( $tag_triangles_vector[0] , $tag_triangles_vector[1] , $tag_triangles_vector[2] )
                                ( $tag_triangles_vector[3] , $tag_triangles_vector[4] , $tag_triangles_vector[5] )
                                ( $tag_triangles_vector[6] , $tag_triangles_vector[7] , $tag_triangles_vector[8] )

  Attach bone index:$attach_bone_number
  Tag position vector to bone:( $tag_pos_to_bone[0] , $tag_pos_to_bone[1] , $tag_pos_to_bone[2] )
  Bone index list size:$bone_number_list_size
  Bone index list offset:$bone_list_offset
  Tag data size:$tag_data_size
  Bone index list:( $bone_index_list_a )


EOM

}
$output = $output . "</PRE></BODY></HTML>";

####################################################

if(!open(IN,">$output_file")){print"Oops!";exit;}

print IN $output;

close(IN);

####################################################

sub cut{

$g = '';

for ( $r = 0; $r < $_[0]; $r++ ){

$g = substr($CUTDATA,$p,2) . $g;

$p = $p + 2;

}

return $g;

}
