# MDM to MD3 mesh convert

$char = 'C';
$sint16 = 's';
$uint32 = 'I';
$float = 'f';

$file_name_mdm = 'c:/cgi/body.mdm'; # Filename to import
$file_name_md3 = 'c:/cgi/body.md3'; # Filename to export

####################################################

print <<EOM;
---------------------------------------------
MDM Analyzer alpha version by ikanatto.
---------------------------------------------
EOM

if(!open(MDM,$file_name_mdm)){print"Failed to open file.\n"; exit;}else{print"Opened MDM file.\nReading data.\n";}

binmode MDM;

while($DATA[$i] = unpack("H*",<MDM>)){$i++;}

close(MDM);

$CUTDATA = join('',@DATA);

print"Data loaded.\nStarting coversion.\n";

####################################################

$mdm_ident = &cut( 1 * 4 );
$version = &cut( 4 * 1 );
$mdm_name = &cut( 1 * 64 );
$LoD_scale = &cut( 4 * 1 ); # ? not sure this detail
$LoD_bias = &cut( 4 * 1 ); # ?? maybe determination of LoD with angle state
$num_surfaces = hex( &cut( 4 * 1 ) );
$surface_data_offset = hex( &cut( 4 * 1 ) );
$num_tags = hex( &cut( 4 * 1 ) );
$tag_data_offset = hex( &cut( 4 * 1 ) );
$file_size = hex( &cut( 4 * 1 ) );

###################################################

for ($aa = 0; $aa < 64; $aa++ ){
$mdm_name_str = pack("H2",substr($mdm_name,$aa*2,2)) . $mdm_name_str;
}

print <<EOM;

---------------------------------------------
MDM Header section
---------------------------------------------
  MDM model name:$mdm_name_str
  Surface number:$num_surfaces
  Surface data offset:$surface_data_offset
  Tag number:$num_tags
  Tag data offset:$tag_data_offset
  File size(Byte):$file_size

EOM

####################################################

&make_header;

####################################################

$p = $tag_data_offset * 2;

for ( $tn = 0; $tn < $num_tags; $tn++ ){

#$tn = 0;

$t_name = '';
@bone_index_list = ('');

$tag_name = &cut( 1 * 64 );

for ( $vi = 0; $vi < 9; $vi++ ) {

$tag_triangles_vector[$vi] = unpack( "f" , pack( "H*" , &cut( 1 ) . &cut( 1 ) . &cut( 1 ) . &cut( 1 )) );

}

$attach_bone_number = hex( &cut( 4 * 1 ) ); # silly assumption

for ( $vi = 0; $vi < 3; $vi++ ) {

$tag_pos_to_bone[$vi] = unpack( "f" , pack( "H*" , &cut( 1 ) . &cut( 1 ) . &cut( 1 ) . &cut( 1 ) ) ); # position vector where tag's triangle is near bone

}

$bone_number_list_size = hex( &cut( 4 * 1 ) );

$bone_list_offset = &cut( 4 * 1 ); 

$tag_data_size = hex( &cut( 4 * 1 ) );

for ( $cc = 0; $cc < $bone_number_list_size; $cc++ ) {

$bone_index_list[$cc] = hex( &cut( 4 * 1) );

}

####################################################

for ($aa = 0; $aa < 64; $aa++ ){
$t_name = pack("H2",substr($tag_name,$aa*2,2)) . $t_name;
}

$bone_index_list_a = join(' , ',@bone_index_list);

print<<EOM;

---------------------------------------------
Tag $tn section
---------------------------------------------

  Tag name:$t_name
  Tag triangle vertices vectors:( $tag_triangles_vector[0] , $tag_triangles_vector[1] , $tag_triangles_vector[2] )
                                ( $tag_triangles_vector[3] , $tag_triangles_vector[4] , $tag_triangles_vector[5] )
                                ( $tag_triangles_vector[6] , $tag_triangles_vector[7] , $tag_triangles_vector[8] )

  Attach bone index:$attach_bone_number
  Tag position vector to bone:( $tag_pos_to_bone[0] , $tag_pos_to_bone[1] , $tag_pos_to_bone[2] )
  Bone index list size:$bone_number_list_size
  Bone index list offset:$bone_list_offset
  Tag data size:$tag_data_size
  Bone index list:( $bone_index_list_a )


EOM

&make_tag;

}

###################################################

$p = $surface_data_offset * 2;

###################################################

for ( $sn = 0; $sn < $num_surfaces; $sn++ ){


$point = $p;

$surface_ident = &cut( 4 * 1 ); # 0x0009
$surface_name = &cut( 1 * 64 );
$shader_name = &cut( 1 * 64 );
$shader_index = hex( &cut( 4 * 1 ) );
$unknown1 = &cut( 4 * 1 ); # ???
$surface_header_offset = hex( &cut( 4 * 1 ) ); # Always negative 
$num_vertices = hex( &cut( 4 * 1 ) );
$offset_vertices = &cut( 4 * 1 );
$num_triangles = hex( &cut( 4 * 1 ) );
$offset_triangles = &cut( 4 * 1 );
$offset_collaspemap = &cut( 4 * 1 ); # not sure but probably offset
$unknown2 = &cut( 4 * 1); # ??? kind of number or index
$offset_bonerefs = &cut( 4 * 1 ); # ??? offset maybe
$offset_surface_data_end = hex( &cut( 4 * 1 ) );

####################################################

$sur_name = '';
$sdr_name = '';
$vert = '';
$cood = '';
$tri = '';

for ($aa = 0; $aa < 64; $aa++ ){
$sur_name = pack("H2",substr($surface_name,$aa*2,2)) . $sur_name;
}

for ($aa = 0; $aa < 64; $aa++ ){
$sdr_name = pack("H2",substr($shader_name,$aa*2,2)) . $sdr_name;
}

print<<EOM;

---------------------------------------------
Surface $sn section
---------------------------------------------
  Surface name:$sur_name
  Shader name:$sdr_name
  Shader index:$shader_index
  Vertex number:$num_vertices
  Vertex data offset:$offset_vertices
  Triangle number:$num_triangles
  Triangle data offset:$offset_triangles
  Collapsemap data offset:$offset_collaspemap
  Bone Reference data offset:$offset_bonerefs
  Surface data size:$offset_surface_data_end

EOM

&make_surface_header;

# VERTEX -> vertex pos & co-odinate pos

for ( $it = 0; $it < $num_vertices; $it++ ){

$vertex_postion_vector_x = unpack( "f" , pack( "H*", &cut( 1 ) . &cut( 1 ) . &cut( 1 ) . &cut( 1 ) ) );
$vertex_postion_vector_y = unpack( "f" , pack( "H*", &cut( 1 ) . &cut( 1 ) . &cut( 1 ) . &cut( 1 ) ) );
$vertex_postion_vector_z = unpack( "f" , pack( "H*", &cut( 1 ) . &cut( 1 ) . &cut( 1 ) . &cut( 1 ) ) );

$texture_coordinates_pos_u = unpack( "f" , pack( "H*" , &cut( 1 ) . &cut( 1 ) . &cut( 1 ) . &cut( 1 ) ) );
$texture_coordinates_pos_v = unpack( "f" , pack( "H*" , &cut( 1 ) . &cut( 1 ) . &cut( 1 ) . &cut( 1 ) ) );
$num_bone_weights = hex( &cut( 4 * 1 ) );

for ($bi = 0; $bi < $num_bone_weights; $bi++ ){
$bone_index = &cut( 4 * 1 );
$weight = &cut( 4 * 1 );
$bone_space = &cut( 4 * 3 );

}

$vert = $vert . unpack( "H*" , pack( "s" , int( $vertex_postion_vector_x * 32768 ) ) ) . unpack( "H*" , pack( "s" , int( $vertex_postion_vector_y * 32768 ) ) ) . unpack( "H*" , pack( "s" , int( $vertex_postion_vector_z * 32768 ) ) ) . &normal;

$cood = $cood . unpack( "H*" , pack( "f" , $texture_coordinates_pos_u ) ) . unpack( "H*" , pack( "f" , $texture_coordinates_pos_v ) );


} # end of vertex routine

print $vert . "\n" . $cood . "\n" . length( $vert ) . "\n" . length( $cood ) . "\n";

#

$tri = $tri . substr( $CUTDATA , $p , $num_triangles * 3 * 2 * 4 );

print $tri . "\n" . length( $tri ) . "\n";

#

$out = $out . $tri . $vert . $cood;

#

$p = $point + $offset_surface_data_end * 2;

}
###################################################

substr( $out , 104 * 2 , 8 ) = unpack( "H8" , pack( $uint32 . "1" , length( $out ) / 2 ) );

###################################################

print $out."\n";
print length($out)/2 . "\n";
print 112 * $num_tags + 108 . "\n";
print int( $tag_triangles_vector[0] * 32768 ) . "\n";
print int( $vertex_postion_vector_x * 32768 ) . "\n";
print unpack( "H*" , pack( "s" , int( $vertex_postion_vector_x * 32768 ) ) );
print "\n" . unpack( "H8" , pack( $uint32 . 1 , length( $out ) ) );

####################################################

for ( $i = 0; $i < length( $out ) / 2; $i++ ){
$fout = $fout . pack( "H2" , substr( $out , $i * 2 , 2 ) );
}

if(!open(MD3,">$file_name_md3")){print 'Oops!';exit;}
binmode MD3;
print MD3 $fout;
close(MD3);

####################################################

# Making MD3 Header

sub make_header{

&add( 'IDP3' , $char , 4 ); #md3 identification
&add( 15 , $uint32 , 1 ); #version
&add( $mdm_name , $char , 64 ); #md3 name
&add( 0 , $uint32 , 1 ) #flag?
&add( 0 , $uint32 , 1 ); #number of bone frames
&add( $num_tags , $uint32 , 1 ); #number of tags
&add( $num_surfaces , $uint32 , 1 ); #number of meshes
&add( 0 , $uint32 , 1 ); #max texture number
&add( 108 , $uint32 , 1 ); #size of header, fixed to 108
&add( 108 , $uint32 , 1 ); #offset of tags
&add( 112 * $num_tags + 108 , $uint32 , 1 ); #offset of meshes
&add( $size_of_file , $uint32 , 1); # size of this md3 file

}

###################################################

sub make_tag{

&add( $t_name , $char , 64 ); # tag name
for($opp = 0; $opp < 3; $opp++){
&add( $tag_pos_to_bone[$opp] , $float , 1 ); #position to model
}
for($oop = 0; $oop < 9; $oop++){
&add( $tag_triangles_vector[$oop] , $float , 1 ) # tag triangle matrix
}

}
###################################################

sub make_surface_header{

&add( 'IDP3' , $char , 4 ); #identification
&add( $sur_name , $char , 64 ); # name of surface
&add( 0 , $uint32 , 1 ); #flag?
&add( 0 , $uint32 , 1 ); # number of frames
&add( 0 , $uint32 , 1 ); # number of shaders?
&add( $num_vertices , $uint32 , 1 ); # number of vertices
&add( $num_triangles , $uint32 , 1 ); #number of triangles
&add( 108 , $uint32 , 1 ); # offset to triangles
&add( 12 * $num_triangles + 108 , $uint32 , 1 ); # offset to shader?
&add( 12 * $num_triangles + 108 , $uint32 , 1 ); # offset to uv mapping
&add( 12 * $num_triangles + 108 + 8 * $num_vertex , $uint32 , 1 ); # offset to vertex xyz + normal vector
&add( 12 * $num_triangles + 108 + 16 * $num_vertex , $uint32 , 1 ); # end of this surface data

}


###################################################

# add( DATA , TYPE , LENGTH ) => 4bit strings (0-F) to out string data.

sub add{

$ret = '';

if ( $_[1] eq 'C'){

$ret = unpack( "H" . $_[2] * 2 , $_[0] );

}else{

$ret = unpack( "H8" , pack( $_[1] . $_[2] , $_[0] ) );

}

$out = $out . $ret;

}

#

sub cut{

$g = '';

for ( $r = 0; $r < $_[0]; $r++ ){

$g = substr($CUTDATA,$p,2) . $g;

$p = $p + 2;

}

return $g;

}

sub normal{

$lng = int( atan2( $vertex_postion_vector_y , $vertex_postion_vector_x ) * 255 / (2 * 3.1415 ) );

$lat = int( ( -atan2( ( 1 - ( $vertex_postion_vector_z / 32768 ) ^ 2 ) ,  $vertex_postion_vector_z / 32768 )  + 1.5708 ) * 255 / ( 2 * 3.1415 ) );

return unpack( "H*" , pack( "c" , $lng ) ) . unpack( "H*" , pack( "c" , $lat ) );

}