// mdm.h
// Definition of MDM Structure

struct Point3
{

	float		x;
	float		y;
	float		z;

};

struct Point2{

	float		u;
	float		v;

};


struct MDMHeader
{

	char		MDMIdent[4];
	long		Version;
	char		MDMName[64];
	float		LoDScale;
	float		LoDBias;
	long		NumSurface;
	long		OffsetSurface;
	long		NumTag;
	long		OffsetTag;
	long		OffsetEOF;

};


struct MDMSurfaceHeader
{

	long		SurfaceIdent;
	char		SurfaceName[64];
	char		ShaderName[64];
	long		ShaderIndex;
	long		LoDMin;
	long		OffsetSurfaceHeader;
	long		NumVertex;
	long		OffsetVertex;
	long		NumTriangle;
	long		OffsetTriangle;
	long		OffsetCollapsemap;
	long		NumBoneref;
	long		OffsetBoneref;
	long		OffsetNextSurface;

};

struct MDMVertex
{

	Point3		Normal;
	Point2		TextureCoord;
	long		NumBoneWeight;

};

struct MDMBoneWeight
{

	long		Boneindex;
	float		Weight;
	Point3		Position;

};

struct MDMTriangle
{

	long		VertexIndex1;
	long		VertexIndex2;
	long		VertexIndex3;

};

struct MDMTag
{

	char		TagName[64];
	Point3		RotationMatrix[3];
	long		AttachBoneNumber;
	Point3		OriginPosition;
	long		NumBoneList;
	long		OffsetBoneList;
	long		OffsetNextTag;
	
};

struct MDMWeight
{

	long		BoneIndex;
	float		Weight;
	Point3		Coord;

};

// EOF