// mdx.h
// definition MDX structure

struct MDXHeader
{
	char		MDXIdent[4];
	long		MDXVersion;
	char		MDXName[64];
	long		NumFrame;
	long		NumBone;
	long		OffsetFrame;
	long		OffsetBone;
	long		TorsoParent;
	long		OffsetEOF;
};

struct MDXFrame
{
	Point3		BBoxMin;
	Point3		BBoxMax;
	Point3		LocalOrigin;
	float		Radius;
	Point3		OffsetParent;
};

struct MDXCompFrame
{
	short int	AnglePitch;
	short int	AngleYaw;
	short int	AngleRoll;
	short int	Unused;
	short int	OffsetPitch;
	short int	OffsetYaw;
};

struct MDXBone
{
	char		BoneName[64];
	signed long	ParentIndex;
	float		TorsoWeight;
	float		ParentDist;
	long		Flag;
};

// EOF